unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

const
  division = 16;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Image2: TImage;
    Button1: TButton;
    ColorDialog1: TColorDialog;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure DrawGradient(image: TImage; cColor: TColor);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
uses Math;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if ColorDialog1.Execute then
  begin
    Image1.Canvas.Brush.Color := Colordialog1.Color;
    Image1.Canvas.FillRect(Rect(0, 0, Image1.Width, Image1.Height));
    DrawGradient(Image2, ColorDialog1.Color);
  end;
end;

procedure TForm1.DrawGradient(image: TImage; cColor: TColor);
var
  R, G, B: Double;
  H, S, L: Double;
  i: integer;
  dH: Double;

  // input H, S, L to Get R, G, B
  // H is 0~360, S, L is 0~1; R, G, B is 0~1
  procedure HSL2RGB(H, S, L:Double; var R, G, B: Double);
  var
    mx, mn: Double;
    function f(h, mx, mn: Double): Double;
    begin
      f:=0;
      if h<0 then h:=h+360;
      if h>=360 then h:=h-360;
      if (h>=0) and (h<60) then
        f := mn+(mx-mn)*h/60
      else if (h>=60) and (h<180) then
        f := mx
      else if (h>=180) and (h<240) then
        f := mn+(mx-mn)*(240-h)/60
      else if (h>=240) then
        f := mn
      // h not between  0~360 !!
      else ShowMessage('h= '+FloatToStr(h)+' error!');
    end;
  begin
    if L <=0.5 then
    begin
      mx := L * (1+S);
      mn := 2*L-mx;
    end
    else
    begin
      mx := L*(1-S)+S;
      mn := 2*L-mx;
    end;

    R := f(H+120, mx, mn);
    G := f(H, mx, mn);
    B := f(H-120, mx, mn);
    // Retrieve R, G, B from H, S, L
  end;

  // input R, G, B to Get H, S, L
  // R, G, B is 0~1; H is 0~360, S, L is 0~1
  procedure RGB2HSL(R, G, B:Double; var H, S, L:Double);
  var
    mx, mn, cd: Double;
  begin
    mx := MaxValue([R, G, B]);
    mn := MinValue([R, G, B]);
    cd := mx - mn;
    L := ( mx + mn ) / 2;
    if(cd=0) then
    begin
      H := 0;
      S := 0;
    end
    else
    begin
      if(L<=0.5) then S:=cd/(mx+mn)
      else S:=cd/(2-(mx+mn));
      if(R=mx) then H:=(G-B)/cd
      else if(G=mx) then H:=2+(B-R)/cd
      else if(B=mx) then H:=4+(R-G)/cd;
    end;
    H:=H*60;
    if(H<0) then H:=H+360;
    if(H>=360) then H:=H-360;
    // H, S, L has been converted from R, G, B
    // The Light Bar is based on value L
    // H is 0~360, S, L is 0~1!!
  end;

  // R, G, B is 0~1
  function RGB2TColor(R, G, B: Double): TColor;
  var
    iR, iG, iB: integer;
  begin
    iR := Round(R*255);
    iG := Round(G*255);
    iB := Round(B*255);
    Result := iR or (iG shl 8) or (iB shl 16);
  end;

  // get R, G, B From TColor
  // R, G, B is 0~1
  procedure TColor2RGB(cColor: TColor; var R, G, B:Double);
  begin
    R:=cColor and $000000FF;
    G:=cColor and $0000FF00 shr 8;
    B:=cColor and $00FF0000 shr 16;
    R:=R/255; G:=G/255; B:=B/255;
  end;

begin
  TColor2RGB(cColor, R, G, B);
  RGB2HSL(R, G, B, H, S, L);
  dH := Image2.Height / division;
  for i := 0 to division-1 do
  begin
    L := i;
    L := L/division;
    HSL2RGB(H, S, L, R, G, B);

    // output the color rectangle
    Image2.Canvas.Brush.Color := RGB2TColor(R, G, B);
    Image2.Canvas.FillRect(Rect(0, Round(i*dH), Image2.Width, Round((i+1)*dH)));
  end;
end;

end.
